Index: src/FinkiChattery/FinkiChattery.Database/dbo/Tables/User/Seed/Users.Debug.Seed.sql
===================================================================
--- src/FinkiChattery/FinkiChattery.Database/dbo/Tables/User/Seed/Users.Debug.Seed.sql	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Database/dbo/Tables/User/Seed/Users.Debug.Seed.sql	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -7,6 +7,5 @@
 	FROM (
 	VALUES
-		(1, N'stojkovmarko1@gmail.com',  N'STOJKOVMARKO1@GMAIL.COM', 'stojkovmarko1@gmail.com',  N'STOJKOVMARKO1@GMAIL.COM', 1, N'AQAAAAEAACcQAAAAELBRjOGmA/Dh8BPvcPMA1vmk1jjvyDd/9/lO/3shoBt7z9NfiKJR+Ckp/2+6BVpyLw==', N'MMDEZ3RWADCRM4PTTKSEZNQYNH5V7UVA', N'08309369-24a1-470c-9ab1-65a250cafd4e', null, 0, 0, null, 1, 0, 0),
-		(2, N'stojkovmarko1234@gmail.com',  N'STOJKOVMARKO1234@GMAIL.COM', 'stojkovmarko1234@gmail.com',  N'STOJKOVMARKO1234@GMAIL.COM', 1, N'AQAAAAEAACcQAAAAELBRjOGmA/Dh8BPvcPMA1vmk1jjvyDd/9/lO/3shoBt7z9NfiKJR+Ckp/2+6BVpyLw==', N'MMDEZ3RWADCRM4PTTKSEZNQYNH5V7UVA', N'08309369-24a1-470c-9ab1-65a250cafd4e', null, 0, 0, null, 1, 0, 2)
+		(1, N'stojkovmarko1@gmail.com',  N'STOJKOVMARKO1@GMAIL.COM', 'stojkovmarko1@gmail.com',  N'STOJKOVMARKO1@GMAIL.COM', 1, N'AQAAAAEAACcQAAAAELBRjOGmA/Dh8BPvcPMA1vmk1jjvyDd/9/lO/3shoBt7z9NfiKJR+Ckp/2+6BVpyLw==', N'MMDEZ3RWADCRM4PTTKSEZNQYNH5V7UVA', N'08309369-24a1-470c-9ab1-65a250cafd4e', null, 0, 0, null, 1, 0, 0)
 		)
 		AS temp ([ID], [UserName], [NormalizedUserName], [Email], [NormalizedEmail], [EmailConfirmed], [PasswordHash], [SecurityStamp], [ConcurrencyStamp], [PhoneNumber], [PhoneNumberConfirmed], [TwoFactorEnabled], [LockoutEnd], [LockoutEnabled], [AccessFailedCount], [Role])
Index: src/FinkiChattery/FinkiChattery.Domain/FinkiChattery.Domain.csproj
===================================================================
--- src/FinkiChattery/FinkiChattery.Domain/FinkiChattery.Domain.csproj	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
+++ src/FinkiChattery/FinkiChattery.Domain/FinkiChattery.Domain.csproj	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -0,0 +1,12 @@
+<Project Sdk="Microsoft.NET.Sdk">
+
+  <PropertyGroup>
+    <TargetFramework>netcoreapp3.1</TargetFramework>
+  </PropertyGroup>
+
+  <ItemGroup>
+    <PackageReference Include="FluentValidation" Version="9.5.4" />
+    <PackageReference Include="FluentValidation.AspNetCore" Version="9.5.4" />
+  </ItemGroup>
+
+</Project>
Index: src/FinkiChattery/FinkiChattery.HangfireDatabase/FinkiChattery.HangfireDatabase.sqlproj
===================================================================
--- src/FinkiChattery/FinkiChattery.HangfireDatabase/FinkiChattery.HangfireDatabase.sqlproj	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.HangfireDatabase/FinkiChattery.HangfireDatabase.sqlproj	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,3 +1,3 @@
-<?xml version="1.0" encoding="utf-8"?>
+﻿<?xml version="1.0" encoding="utf-8"?>
 <Project DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003" ToolsVersion="4.0">
   <PropertyGroup>
@@ -8,5 +8,5 @@
     <ProjectVersion>4.1</ProjectVersion>
     <ProjectGuid>{c4cb8596-3f3a-4b4e-bec5-0720ff7cd532}</ProjectGuid>
-    <DSP>Microsoft.Data.Tools.Schema.Sql.Sql150DatabaseSchemaProvider</DSP>
+    <DSP>Microsoft.Data.Tools.Schema.Sql.Sql130DatabaseSchemaProvider</DSP>
     <OutputType>Database</OutputType>
     <RootPath>
@@ -14,5 +14,5 @@
     <RootNamespace>FinkiChattery.HangfireDatabase</RootNamespace>
     <AssemblyName>FinkiChattery.HangfireDatabase</AssemblyName>
-    <ModelCollation>1033,CI</ModelCollation>
+    <ModelCollation>1033, CI</ModelCollation>
     <DefaultFileStructure>BySchemaAndSchemaType</DefaultFileStructure>
     <DeployToDatabase>True</DeployToDatabase>
@@ -23,6 +23,4 @@
     <IncludeCompositeObjects>True</IncludeCompositeObjects>
     <TargetDatabaseSet>True</TargetDatabaseSet>
-    <DefaultCollation>SQL_Latin1_General_CP1_CI_AS</DefaultCollation>
-    <DefaultFilegroup>PRIMARY</DefaultFilegroup>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -55,35 +53,8 @@
     <VisualStudioVersion Condition="'$(SSDTExists)' == ''">11.0</VisualStudioVersion>
   </PropertyGroup>
-  <Import Condition="'$(NetCoreBuild)' != 'true' AND '$(SQLDBExtensionsRefPath)' != ''" Project="$(SQLDBExtensionsRefPath)\Microsoft.Data.Tools.Schema.SqlTasks.targets" />
-  <Import Condition="'$(NetCoreBuild)' != 'true' AND '$(SQLDBExtensionsRefPath)' == ''" Project="$(MSBuildExtensionsPath)\Microsoft\VisualStudio\v$(VisualStudioVersion)\SSDT\Microsoft.Data.Tools.Schema.SqlTasks.targets" />
+  <Import Condition="'$(SQLDBExtensionsRefPath)' != ''" Project="$(SQLDBExtensionsRefPath)\Microsoft.Data.Tools.Schema.SqlTasks.targets" />
+  <Import Condition="'$(SQLDBExtensionsRefPath)' == ''" Project="$(MSBuildExtensionsPath)\Microsoft\VisualStudio\v$(VisualStudioVersion)\SSDT\Microsoft.Data.Tools.Schema.SqlTasks.targets" />
   <ItemGroup>
     <Folder Include="Properties" />
-    <Folder Include="HangFire\" />
-    <Folder Include="HangFire\Tables\" />
-    <Folder Include="Security\" />
   </ItemGroup>
-  <ItemGroup>
-    <Build Include="HangFire\Tables\Schema.sql" />
-    <Build Include="HangFire\Tables\Job.sql" />
-    <Build Include="HangFire\Tables\State.sql" />
-    <Build Include="HangFire\Tables\JobParameter.sql" />
-    <Build Include="HangFire\Tables\JobQueue.sql" />
-    <Build Include="HangFire\Tables\Server.sql" />
-    <Build Include="HangFire\Tables\List.sql" />
-    <Build Include="HangFire\Tables\Set.sql" />
-    <Build Include="HangFire\Tables\Counter.sql" />
-    <Build Include="HangFire\Tables\Hash.sql" />
-    <Build Include="HangFire\Tables\AggregatedCounter.sql" />
-    <Build Include="Security\HangFire.sql" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="FinkiChattery.HangfireDatabase.publish.xml" />
-  </ItemGroup>
-  <Import Condition="'$(NetCoreBuild)' == 'true'" Project="$(NETCoreTargetsPath)\Microsoft.Data.Tools.Schema.SqlTasks.targets" />
-  <ItemGroup>
-    <PackageReference Condition="'$(NetCoreBuild)' == 'true'" Include="Microsoft.NETFramework.ReferenceAssemblies" Version="1.0.0" PrivateAssets="All" />
-  </ItemGroup>
-  <Target Name="BeforeBuild">
-    <Delete Files="$(BaseIntermediateOutputPath)\project.assets.json" />
-  </Target>
 </Project>
Index: src/FinkiChattery/FinkiChattery.Identity/FinkiChattery.Identity.csproj
===================================================================
--- src/FinkiChattery/FinkiChattery.Identity/FinkiChattery.Identity.csproj	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Identity/FinkiChattery.Identity.csproj	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -3,5 +3,4 @@
   <PropertyGroup>
     <TargetFramework>netcoreapp3.1</TargetFramework>
-    <Configurations>Debug;Release;Debug_Docker</Configurations>
   </PropertyGroup>
 
Index: src/FinkiChattery/FinkiChattery.Identity/Startup.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Identity/Startup.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Identity/Startup.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -28,11 +28,6 @@
             services.AddControllersWithViews();
 
-            string connectionString = "DefaultConnection";
-#if DEBUG_DOCKER
-            connectionString = "DefaultConnectionDocker";
-#endif
-
             services.AddDbContextPool<ApplicationDbContext<ApplicationUser>>(options =>
-                options.UseSqlServer(Configuration.GetConnectionString(connectionString)));
+                options.UseSqlServer(Configuration.GetConnectionString("DefaultConnection")));
 
             services.AddIdentityServerAndIdentityProvider(AppSettings);
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -22,5 +22,4 @@
             builder.Property(x => x.CorrectAnswer).HasColumnName(@"CorrectAnswer").HasColumnType("bit").IsRequired();
             builder.Property(x => x.CreatedOn).HasColumnName(@"CreatedOn").HasColumnType("smalldatetime").IsRequired();
-            builder.Property(x => x.VotesCount).HasColumnName(@"VotesCount").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
 
             builder.HasOne(x => x.Question).WithMany(x => x.Answers).HasForeignKey(x => x.QuestionFk).OnDelete(DeleteBehavior.Restrict);
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerResponseConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerResponseConfig.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerResponseConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -27,6 +27,6 @@
             builder.Property(x => x.CreatedOn).HasColumnName(@"CreatedOn").HasColumnType("smalldatetime").IsRequired();
 
-            builder.HasOne(x => x.Answer).WithMany(x => x.AnswerResponses).HasForeignKey(x => x.AnswerFk).OnDelete(DeleteBehavior.Cascade);
-            builder.HasOne(x => x.Student).WithMany().HasForeignKey(x => x.StudentFk).OnDelete(DeleteBehavior.Restrict);
+            builder.HasOne(x => x.Answer).WithMany(x => x.AnswerResponses).HasForeignKey(x => x.AnswerFk).OnDelete(DeleteBehavior.Restrict);
+            builder.HasOne(x => x.Student).WithMany().HasForeignKey(x => x.AnswerFk).OnDelete(DeleteBehavior.Restrict);
         }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionCategoryConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionCategoryConfig.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionCategoryConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -26,5 +26,5 @@
 
             builder.HasOne(x => x.Question).WithMany(x => x.QuestionCategories).HasForeignKey(x => x.QuestionFk).OnDelete(DeleteBehavior.Restrict);
-            builder.HasOne(x => x.Category).WithMany().HasForeignKey(x => x.CategoryFk).OnDelete(DeleteBehavior.Restrict);
+            builder.HasOne(x => x.Category).WithMany().HasForeignKey(x => x.QuestionFk).OnDelete(DeleteBehavior.Restrict);
         }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionConfig.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/QuestionConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,5 +1,10 @@
-﻿using FinkiChattery.Persistence.Models;
-using Microsoft.EntityFrameworkCore;
+﻿using Microsoft.EntityFrameworkCore;
 using Microsoft.EntityFrameworkCore.Metadata.Builders;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using FinkiChattery.Persistence.Models;
 
 namespace FinkiChattery.Persistence.Configurations
@@ -18,5 +23,5 @@
 
             builder.Property(x => x.Title).HasColumnName(@"Title").HasColumnType("nvarchar").IsRequired().HasMaxLength(500);
-            builder.Property(x => x.Text).HasColumnName(@"Text").HasColumnType("nvarchar").IsRequired().HasMaxLength(4000);
+            builder.Property(x => x.TeamFk).HasColumnName(@"Team").HasColumnType("nvarchar").IsRequired().HasMaxLength(4000);
             builder.Property(x => x.StudentFk).HasColumnName(@"StudentFk").HasColumnType("bigint").IsRequired();
             builder.Property(x => x.CreatedOn).HasColumnName(@"CreatedOn").HasColumnType("smalldatetime").IsRequired();
@@ -24,6 +29,4 @@
             builder.Property(x => x.Views).HasColumnName(@"Views").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
             builder.Property(x => x.LastActiveOn).HasColumnName(@"LastActiveOn").HasColumnType("smalldatetime").IsRequired();
-            builder.Property(x => x.Search).HasComputedColumnSql(@"Search").HasColumnType("nvarchar").ValueGeneratedOnAddOrUpdate().HasMaxLength(4000).IsRequired();
-            builder.Property(x => x.AnswersCount).HasColumnType(@"AnswersCount").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
 
             builder.HasOne(x => x.Student).WithMany(x => x.Questions).HasForeignKey(x => x.StudentFk).OnDelete(DeleteBehavior.NoAction);
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/StudentConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/StudentConfig.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/StudentConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,6 +1,10 @@
-﻿using FinkiChattery.Persistence.Models;
-using Microsoft.EntityFrameworkCore;
+﻿using Microsoft.EntityFrameworkCore;
 using Microsoft.EntityFrameworkCore.Metadata.Builders;
 using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using FinkiChattery.Persistence.Models;
 
 namespace FinkiChattery.Persistence.Configurations
@@ -23,5 +27,4 @@
             builder.Property(x => x.ReportReputation).HasColumnName(@"ReportReputation").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
             builder.Property(x => x.ImageUrl).HasColumnName(@"ImageUrl").HasColumnType("nvarchar").IsRequired().HasMaxLength(1000);
-            builder.Property(x => x.LastCheckedNotifications).HasColumnName(@"LastCheckedNotifications").HasColumnType("smalldatetime").IsRequired().HasConversion(v => v, v => DateTime.SpecifyKind(v, DateTimeKind.Utc));
 
             builder.HasOne(x => x.ApplicationUser).WithOne().HasForeignKey<Student>(x => x.ApplicationUserFk).OnDelete(DeleteBehavior.Restrict);
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -0,0 +1,31 @@
+﻿using Microsoft.EntityFrameworkCore;
+using Microsoft.EntityFrameworkCore.Metadata.Builders;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using FinkiChattery.Persistence.Models;
+
+namespace FinkiChattery.Persistence.Configurations
+{
+    public class UpvoteConfig : BaseConfig<Upvote>
+    {
+        public UpvoteConfig(string schema) : base(schema)
+        {
+        }
+
+        public override void Configure(EntityTypeBuilder<Upvote> builder)
+        {
+            base.Configure(builder);
+
+            builder.ToTable("Upvote", Schema);
+
+            builder.Property(x => x.StudentFk).HasColumnName(@"StudentFk").HasColumnType("bigint").IsRequired();
+            builder.Property(x => x.AnswerFk).HasColumnName(@"AnswerFk").HasColumnType("bigint").IsRequired();
+
+            builder.HasOne(x => x.Student).WithMany().HasForeignKey(x => x.StudentFk).OnDelete(DeleteBehavior.Restrict);
+            builder.HasOne(x => x.Answer).WithMany(x => x.Upvotes).HasForeignKey(x => x.AnswerFk).OnDelete(DeleteBehavior.Restrict);
+        }
+    }
+}
Index: src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -23,6 +23,5 @@
         public DbSet<TeacherTeam> TeacherTeams { get; set; }
         public DbSet<Team> Teams { get; set; }
-        public DbSet<Vote> Votes { get; set; }
-        public DbSet<StudentNotification> StudentNotifications { get; set; }
+        public DbSet<Upvote> Upvotes { get; set; }
 
         protected override void OnModelCreating(ModelBuilder builder)
@@ -43,6 +42,5 @@
             builder.ApplyConfiguration(new TeacherTeamConfig(schema));
             builder.ApplyConfiguration(new TeamConfig(schema));
-            builder.ApplyConfiguration(new VoteConfig(schema));
-            builder.ApplyConfiguration(new StudentNotificationConfig(schema));
+            builder.ApplyConfiguration(new UpvoteConfig(schema));
         }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/FinkiChattery.Persistence.csproj
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/FinkiChattery.Persistence.csproj	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/FinkiChattery.Persistence.csproj	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -3,5 +3,4 @@
   <PropertyGroup>
     <TargetFramework>netcoreapp3.1</TargetFramework>
-    <Configurations>Debug;Release;Debug_Docker</Configurations>
   </PropertyGroup>
 
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -6,11 +6,4 @@
     public class Answer : BaseEntity
     {
-        public Answer() : base()
-        {
-            CreatedOn = DateTime.UtcNow;
-            VotesCount = 0;
-            CorrectAnswer = false;
-        }
-
         public string Text { get; set; }
 
@@ -27,9 +20,7 @@
         public DateTime CreatedOn { get; set; }
 
-        public long VotesCount { get; set; }
+        public virtual IEnumerable<Upvote> Upvotes { get; set; }
 
-        public virtual ICollection<Vote> Votes { get; set; }
-
-        public virtual ICollection<AnswerResponse> AnswerResponses { get; set; }
+        public virtual IEnumerable<AnswerResponse> AnswerResponses { get; set; }
 
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/AnswerResponse.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/AnswerResponse.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/AnswerResponse.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,3 +1,7 @@
 ﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace FinkiChattery.Persistence.Models
@@ -5,9 +9,4 @@
     public class AnswerResponse : BaseEntity
     {
-        public AnswerResponse() : base()
-        {
-            CreatedOn = DateTime.UtcNow;
-        }
-
         public string Text { get; set; }
 
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Base/BaseEntity.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Base/BaseEntity.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Base/BaseEntity.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,3 +1,7 @@
 ﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace FinkiChattery.Persistence.Models
@@ -5,9 +9,4 @@
     public class BaseEntity
     {
-        public BaseEntity()
-        {
-            Uid = Guid.NewGuid();
-        }
-
         public long Id { get; set; }
 
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Category.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Category.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Category.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,10 +1,12 @@
-﻿namespace FinkiChattery.Persistence.Models
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace FinkiChattery.Persistence.Models
 {
     public class Category : BaseEntity
     {
-        public Category() : base()
-        {
-        }
-
         public string Name { get; set; }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,3 +1,9 @@
-﻿namespace FinkiChattery.Persistence.Models
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace FinkiChattery.Persistence.Models
 {
     public class Moderator : BaseEntity
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Question.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Question.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Question.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,5 +1,4 @@
 ﻿using System;
 using System.Collections.Generic;
-using System.ComponentModel.DataAnnotations.Schema;
 
 namespace FinkiChattery.Persistence.Models
@@ -7,12 +6,4 @@
     public class Question : BaseEntity
     {
-        public Question() : base()
-        {
-            CreatedOn = DateTime.UtcNow;
-            LastActiveOn = DateTime.UtcNow;
-            Answers = new List<Answer>();
-            QuestionCategories = new List<QuestionCategory>();
-        }
-
         public string Title { get; set; }
 
@@ -33,12 +24,9 @@
         public DateTime LastActiveOn { get; set; }
 
-        [DatabaseGenerated(DatabaseGeneratedOption.Computed)]
-        public string Search { get; set; }
+        public virtual IEnumerable<Answer> Answers { get; set; }
 
-        public long AnswersCount { get; set; }
+        public virtual IEnumerable<QuestionCategory> QuestionCategories { get; set; }
 
-        public virtual ICollection<Answer> Answers { get; set; }
-
-        public virtual ICollection<QuestionCategory> QuestionCategories { get; set; }
+        // TODO: Pole po koe ke pravime queries
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/QuestionCategory.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/QuestionCategory.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/QuestionCategory.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -9,8 +9,4 @@
     public class QuestionCategory : BaseEntity
     {
-        public QuestionCategory() : base()
-        {
-        }
-
         public long QuestionFk { get; set; }
 
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,4 +1,7 @@
 ﻿using System;
 using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace FinkiChattery.Persistence.Models
@@ -6,6 +9,4 @@
     public class Student : BaseEntity
     {
-        public DateTime LastCheckedNotifications { get; set; }
-
         public long ApplicationUserFk { get; set; }
 
@@ -20,11 +21,9 @@
         public string ImageUrl { get; set; }
 
-        public virtual ICollection<Question> Questions { get; set; }
-
-        public virtual ICollection<Answer> Answers { get; set; }
-
-        public virtual ICollection<StudentTeam> StudentTeams { get; set; }
-
-        public virtual ICollection<StudentNotification> StudentNotifications { get; set; }
+        public virtual IEnumerable<Question> Questions { get; set; }
+        
+        public virtual IEnumerable<Answer> Answers { get; set; }
+        
+        public virtual IEnumerable<StudentTeam> StudentTeams { get; set; }
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Teacher.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Teacher.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Teacher.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -13,5 +13,5 @@
         public virtual ApplicationUser ApplicationUser { get; set; }
 
-        public virtual ICollection<TeacherTeam> TeacherTeams { get; set; }
+        public virtual IEnumerable<TeacherTeam> TeacherTeams { get; set; }
 
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Team.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Team.cs	(revision 6738cc08cebfbe351b250a75ae0aaf1295d2ff22)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Team.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -1,3 +1,7 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace FinkiChattery.Persistence.Models
@@ -9,9 +13,9 @@
         public string Description { get; set; }
 
-        public virtual ICollection<Question> Questions { get; set; }
+        public virtual IEnumerable<Question> Questions{ get; set; }
 
-        public virtual ICollection<StudentTeam> TeamStudents { get; set; }
+        public virtual IEnumerable<StudentTeam> TeamStudents { get; set; }
 
-        public virtual ICollection<TeacherTeam> TeamTeachers { get; set; }
+        public virtual IEnumerable<TeacherTeam> TeamTeachers { get; set; }
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs	(revision e6a6d9ae11319e7403580bef69b0f68e2cddd3ef)
@@ -0,0 +1,19 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace FinkiChattery.Persistence.Models
+{
+    public class Upvote : BaseEntity
+    {
+        public long StudentFk { get; set; }
+
+        public virtual Student Student { get; set; }
+
+        public long AnswerFk { get; set; }
+
+        public virtual Answer Answer { get; set; }
+    }
+}
